rand('state',0);
z = randn(1,500);
z = (z-mean(z))/std(z); % Normalize
z = 5 + 3*z;
xhat = zeros(size(z));
for k=1:length(z)-1
   xhat(k+1) = xhat(k)+(1/(k+1))*(z(k+1)-xhat(k));
end
figure, hold
plot([1:1:500],z,'green')
plot([1:1:500],xhat,'LineWidth',3);

% Standard Kalman Filtering Procedure

R = var(z);

%======================================
% Kalman filter algorithm
%======================================

xhat(1,1:size(z)) = 0; % initial state
P(1,1:size(z)) = var(z); % initial covariance

%======================================
% Recursive procedure
%======================================
for k=2:length(z)
    xprev(1,k) = xhat(1,k-1); % state extrapolation
    Pprev(1,k) = P(1,k-1); %covariance extrapolation
    K(1,k) = Pprev(1,k)*(Pprev(1,k)+R)^(-1); %kalman gain
    xhat(1,k) = xprev(1,k)+K(1,k)*(z(1,k)-xprev(1,k)); % update state
    P(1,k) = (1-K(1,k))*Pprev(1,k);% update covariance
end

%======================================
% Results plotting
%======================================
figure, hold
plot([1:1:500],z,'green')
plot([1:1:500],xhat,'LineWidth',3);

return